<?

// GEGEBENE GRÖßEN (werden in der Internetseite erst eingelesen)
  
  // geographische Breite in Grad
  $breite_grad = 48;
  // Schiefe der Ekliptik (Sonne-Erde)
  $ekliptikschiefe_grad = 23.44;
  // Frühlingspunkt für das Jahr 2005
  $startpunkt = 79; // als x-ter Tag des Jahres 
  // aktuelles Datum des Servers
  $datum = date("d.m.Y");
  // Winkelgeschwindigkeit der Erdrotation
  $rotation_grad = 360/24;    // in Grad pro Stunde
  // Definition von Sonnenaufgang (Winkel)
  $aufgang_grad = -50/60;
  
  // Umrechnung der gegebenen Größen
  // Datum in "Tag des Jahres"
  $D1 = floor(275 * date("m") / 9);
  $D2 = floor((date("m") + 9) / 12);
  $D3 = (1 + floor((date("y") - 4 * floor(date("y") / 4) + 2) / 3));
  $tag = $D1 - ($D2 * $D3) + date("d") - 30; 
  // Winkel ins Bogenmaß
  // geographische Breite
  $breite = $breite_grad/180*pi(); 
  // Schiefe der Ekliptik (Sonne-Erde)
  $ekliptikschiefe = $ekliptikschiefe_grad/180*pi();
  // Winkelgeschwindigkeit der Erdrotation
  $rotation = $rotation_grad/180*pi(); // in 1/Stunde 
  // Definition von Sonnenaufgang
  $aufgang = -$aufgang_grad/180*pi();
      
// BERECHNUNG

  // Positionswinkel der Erde
  // Startpunkt ist die Frühjahrs-Tag-und-Nacht-Gleiche
  $positionswinkel = ($tag-$startpunkt)/365*(2*pi());
  // Deklination
  $deklination = $ekliptikschiefe*sin($positionswinkel);
  // Zusätzlich beleuchteter Teil durch Atmosphärische Brechung und Größe der Sonne 
  $zusatz = (2 * cos ($aufgang/2) * sin($aufgang/2)) / (cos($deklination) * cos($breite)); 
  // Beleuchteter Winkel  
  $tagwinkel = 2 * asin(tan($breite)*tan($deklination) + $zusatz) + pi();
  // Sonnenscheindauer
  $tageslaenge = $tagwinkel / $rotation;
  // => Tageslänge in Stunden


// AUSGABE
  
  // Umrechnung der Winkel in Grad
  // Deklination
  $gdeklination = round($deklination/pi()*180, 2);
  // Umrechnung der Sonnenscheindauer
  // Dezimalzahl in ganze Stunden und Minuten
  $stunden =  floor($tageslaenge);    // Abrunden der Dezimalzahl
  $minuten = round((($tageslaenge - $stunden)*60) , 0); // Umrechnung Rest in Minuten

  // Ausgabe der Ergebnisse als HTML-Text
  echo "<p>Heute, am ",$datum," ist der ",$tag,". Tag im Jahr. Die Deklination betr&auml;gt ",$gdeklination," Grad.</p>"; 
  echo "<p>Sonnenscheindauer auf dem ",$breite_grad,". Breitengrad:</p>";
  echo "<h2>",$stunden," Stunden und ",$minuten," Minuten.</h2>";

?>